package com.alastairbreeze.connectedworlds.Engine;

import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.util.glu.GLU.gluPerspective;

import com.alastairbreeze.connectedworlds.Vec3;

public class Camera {

	public Vec3 pos = new Vec3();
	public Vec3 rot = new Vec3();
	float fov,aspect,near,far;
	
	float dist = 7f;
	
	public Camera(){
		fov=70f;
		aspect = (float)Core.WIDTH/(float)Core.HEIGHT;
		near=0.3f;
		far = 200f;
		rot.x = 30f;
		
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(fov,aspect,near,far);
		glMatrixMode(GL_MODELVIEW);
		glEnable(GL_DEPTH_TEST);
	}
	
	public void updateView(){
		if(dist < 8f)dist = 8f;
		if(dist > 10f)dist = 10f;
		if(rot.x < 20f)rot.x = 20f;
		if(rot.x > 45f)rot.x = 45f;

		glRotatef(rot.x,1,0,0);
		glRotatef(rot.y,0,1,0);
		glRotatef(rot.z,0,0,1);
		
		pos.x = -Game.getInstance().player.pos.x + dist*(float)Math.sin(Math.toRadians((double)rot.y))*(float)Math.cos(Math.toRadians((double)rot.x));
		pos.y = pos.y*0.75f + 0.25f*(Game.getInstance().player.pos.y + 2f + dist*(float)Math.sin(Math.toRadians((double)rot.x)));
		pos.z = -Game.getInstance().player.pos.z - dist*(float)Math.cos(Math.toRadians((double)rot.y))*(float)Math.cos(Math.toRadians((double)rot.x));
		
		glTranslatef(pos.x,-pos.y,pos.z);
	}
}
