package com.alastairbreeze.connectedworlds.Engine;

import static org.lwjgl.opengl.GL11.GL_AMBIENT;
import static org.lwjgl.opengl.GL11.GL_BACK;
import static org.lwjgl.opengl.GL11.GL_COLOR_BUFFER_BIT;
import static org.lwjgl.opengl.GL11.GL_COLOR_MATERIAL;
import static org.lwjgl.opengl.GL11.GL_COMPILE;
import static org.lwjgl.opengl.GL11.GL_CULL_FACE;
import static org.lwjgl.opengl.GL11.GL_DEPTH_BUFFER_BIT;
import static org.lwjgl.opengl.GL11.GL_DEPTH_TEST;
import static org.lwjgl.opengl.GL11.GL_DIFFUSE;
import static org.lwjgl.opengl.GL11.GL_DONT_CARE;
import static org.lwjgl.opengl.GL11.GL_EXP;
import static org.lwjgl.opengl.GL11.GL_FILL;
import static org.lwjgl.opengl.GL11.GL_FOG;
import static org.lwjgl.opengl.GL11.GL_FOG_COLOR;
import static org.lwjgl.opengl.GL11.GL_FOG_DENSITY;
import static org.lwjgl.opengl.GL11.GL_FOG_END;
import static org.lwjgl.opengl.GL11.GL_FOG_HINT;
import static org.lwjgl.opengl.GL11.GL_FOG_MODE;
import static org.lwjgl.opengl.GL11.GL_FOG_START;
import static org.lwjgl.opengl.GL11.GL_FRONT;
import static org.lwjgl.opengl.GL11.GL_LEQUAL;
import static org.lwjgl.opengl.GL11.GL_LIGHT0;
import static org.lwjgl.opengl.GL11.GL_LIGHTING;
import static org.lwjgl.opengl.GL11.GL_LINE;
import static org.lwjgl.opengl.GL11.GL_MODELVIEW;
import static org.lwjgl.opengl.GL11.GL_NICEST;
import static org.lwjgl.opengl.GL11.GL_PERSPECTIVE_CORRECTION_HINT;
import static org.lwjgl.opengl.GL11.GL_POINTS;
import static org.lwjgl.opengl.GL11.GL_POLYGON_OFFSET_FILL;
import static org.lwjgl.opengl.GL11.GL_POSITION;
import static org.lwjgl.opengl.GL11.GL_PROJECTION;
import static org.lwjgl.opengl.GL11.GL_SHININESS;
import static org.lwjgl.opengl.GL11.GL_SMOOTH;
import static org.lwjgl.opengl.GL11.glBegin;
import static org.lwjgl.opengl.GL11.glCallList;
import static org.lwjgl.opengl.GL11.glClear;
import static org.lwjgl.opengl.GL11.glClearColor;
import static org.lwjgl.opengl.GL11.glClearDepth;
import static org.lwjgl.opengl.GL11.glColor3f;
import static org.lwjgl.opengl.GL11.glCullFace;
import static org.lwjgl.opengl.GL11.glDepthFunc;
import static org.lwjgl.opengl.GL11.glDisable;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glEnd;
import static org.lwjgl.opengl.GL11.glEndList;
import static org.lwjgl.opengl.GL11.glFog;
import static org.lwjgl.opengl.GL11.glFogf;
import static org.lwjgl.opengl.GL11.glFogi;
import static org.lwjgl.opengl.GL11.glGenLists;
import static org.lwjgl.opengl.GL11.glHint;
import static org.lwjgl.opengl.GL11.glLight;
import static org.lwjgl.opengl.GL11.glLineWidth;
import static org.lwjgl.opengl.GL11.glLoadIdentity;
import static org.lwjgl.opengl.GL11.glMaterial;
import static org.lwjgl.opengl.GL11.glMaterialf;
import static org.lwjgl.opengl.GL11.glMatrixMode;
import static org.lwjgl.opengl.GL11.glNewList;
import static org.lwjgl.opengl.GL11.glOrtho;
import static org.lwjgl.opengl.GL11.glPointSize;
import static org.lwjgl.opengl.GL11.glPolygonMode;
import static org.lwjgl.opengl.GL11.glPolygonOffset;
import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;
import static org.lwjgl.opengl.GL11.glShadeModel;
import static org.lwjgl.opengl.GL11.glVertex3f;
import static org.lwjgl.opengl.GL11.glViewport;

import java.awt.Canvas;
import java.nio.FloatBuffer;

import org.lwjgl.BufferUtils;
import org.lwjgl.LWJGLException;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.Display;
import org.lwjgl.util.glu.Sphere;

import com.alastairbreeze.connectedworlds.MediaLoader;
import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Meshes.Mesh;

public class Core {
	
	public static Core c;
	public Canvas display;
	public static final int HEIGHT = 450;
	public static final int WIDTH = 650;
	public static final String NAME = "Parallel Island";
	private Thread mainThread;
	private boolean running = false;
	public Camera camera;
	private static Sphere sphere;
	public MediaLoader mediaLoader;
	int music = -1;
	long musicStarted = 0l;
	public boolean mute = false;
	
	public Core(MediaLoader ml){
		mediaLoader = ml;
		if(music==-1){
			music = mediaLoader.getAudio("music.au");
		}
	}
	
	public void playMusic(){
		if(System.currentTimeMillis() - musicStarted > 83000l){
			if(music!=-1 && !mute){
				mediaLoader.playAudio(music);
				musicStarted = System.currentTimeMillis();
			}
		}
	}
	
	public void init(){
		display = new Canvas(){
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;
			public final void addNotify(){
				super.addNotify();
				startLWJGL();
			}
			public final void removeNotify(){
				stopLWJGL();
				super.removeNotify();
			}
		};
		display.setSize(HEIGHT,WIDTH);
	}
	
	public void initOther(){
		display.setFocusable(true);
		display.requestFocus();
		display.setIgnoreRepaint(true);
		display.setSize(WIDTH, HEIGHT);
	}

	public static void L(String s){
		System.out.println(s);
	}
	
	public void startLWJGL(){
		mainThread = new Thread(){
			public void run(){
				running = true;
				try {
					Display.setParent(display);
					Display.create();
					initGL();
				} catch (LWJGLException e) {
					e.printStackTrace();
				}
				
				loop();
			}
		};
		mainThread.start();
	}
	
	public void stopLWJGL(){
		running = false;
		try {
			mainThread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	public void loop(){
		while(running){
			Display.sync(60);
			Display.update();
			fps();
			updateMusic();
			update();
			render();
		}
		Display.destroy();
	}
	
	public void update(){
		updateInput();
		Game.getInstance().update();
	}
	
	public void updateMusic(){
		playMusic();
	}
	
	public void updateInput(){
		float v = Game.getInstance().player.speed;
		float rotv = 1.5f;
		if(Game.getInstance().home  || Game.getInstance().rettomenu){
			if(Game.getInstance().rettomenu){
				if(Keyboard.isKeyDown(Keyboard.KEY_RETURN)){
					Game.getInstance().init();
					Game.getInstance().home = true;
					Game.getInstance().paused = true;
					Game.getInstance().guiCurrent = Game.getInstance().guiHome;
					Game.getInstance().rettomenu = false;
				}
			}else{
				if(Keyboard.isKeyDown(Keyboard.KEY_SPACE)){
					Game.getInstance().home = false;
					Game.getInstance().paused = false;
					Game.getInstance().guiCurrent = Game.getInstance().guiGame;
					Game.getInstance().level = 1;
				}
			}
		}else{
			if(!Game.getInstance().paused){
				if(Keyboard.isKeyDown(Keyboard.KEY_W)&&(Keyboard.isKeyDown(Keyboard.KEY_A)||Keyboard.isKeyDown(Keyboard.KEY_D))
						|| Keyboard.isKeyDown(Keyboard.KEY_S)&&(Keyboard.isKeyDown(Keyboard.KEY_A)||Keyboard.isKeyDown(Keyboard.KEY_D))){
					v = v /(float)Math.sqrt(2d);
				}
				
				if(Game.getInstance().player.canRun()){
					v*=Game.getInstance().player.runScale;
				}
				if(Keyboard.isKeyDown(Keyboard.KEY_W)){
					Game.getInstance().player.acc.z-=v*(float)Math.cos(Math.toRadians((double)camera.rot.y));
					Game.getInstance().player.acc.x+=v*(float)Math.sin(Math.toRadians((double)camera.rot.y));
				}
				if(Keyboard.isKeyDown(Keyboard.KEY_S)){
					Game.getInstance().player.acc.z+=v*(float)Math.cos(Math.toRadians((double)camera.rot.y));
					Game.getInstance().player.acc.x-=v*(float)Math.sin(Math.toRadians((double)camera.rot.y));
				}
				
				if(Keyboard.isKeyDown(Keyboard.KEY_A)){
					Game.getInstance().player.acc.z-=v*(float)Math.sin(Math.toRadians((double)camera.rot.y));
					Game.getInstance().player.acc.x-=v*(float)Math.cos(Math.toRadians((double)camera.rot.y));
				}
				if(Keyboard.isKeyDown(Keyboard.KEY_D)){
					Game.getInstance().player.acc.z+=v*(float)Math.sin(Math.toRadians((double)camera.rot.y));
					Game.getInstance().player.acc.x+=v*(float)Math.cos(Math.toRadians((double)camera.rot.y));
				}
				
				if(Keyboard.isKeyDown(Keyboard.KEY_SPACE)){
					Game.getInstance().player.jump();
				}
				if(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)){
					Game.getInstance().player.run = true;
				}else{
					Game.getInstance().player.run = false;
				}
				
				if(Keyboard.isKeyDown(Keyboard.KEY_EQUALS)){
					camera.dist-=0.1f;
				}
				if(Keyboard.isKeyDown(Keyboard.KEY_MINUS)){
					camera.dist+=0.1f;
				}
				
				if(Keyboard.isKeyDown(Keyboard.KEY_TAB)){
		//			Game.getInstance().player.switchUniverse();
				}
				
				if(Keyboard.isKeyDown(Keyboard.KEY_Q) || Mouse.isButtonDown(1)){
					if(!qdown){
						Game.getInstance().player.nextItem();
					}
					qdown = true;
				}else{
					qdown = false;
				}
				if(Keyboard.isKeyDown(Keyboard.KEY_E) || Mouse.isButtonDown(0)){
					if(!edown){
						Game.getInstance().player.useItem();
					}
					edown = true;
				}else{
					edown = false;
				}
			}else{
				if(Game.getInstance().carryon){
					if(Keyboard.isKeyDown(Keyboard.KEY_SPACE)){
						Game.getInstance().init();
						Game.getInstance().home = false;
						Game.getInstance().paused = false;
						Game.getInstance().guiCurrent = Game.getInstance().guiGame;
						Game.getInstance().rettomenu = false;
					}
				}else{
					if(Keyboard.isKeyDown(Keyboard.KEY_R)){
						Game.getInstance().init();
						Game.getInstance().home = true;
						Game.getInstance().paused = true;
						Game.getInstance().guiCurrent = Game.getInstance().guiHome;
						Game.getInstance().rettomenu = false;
					}
				}
			}
			
			
			if(Keyboard.isKeyDown(Keyboard.KEY_LEFT)){
				camera.rot.y-=rotv;
			}
			if(Keyboard.isKeyDown(Keyboard.KEY_RIGHT)){
				camera.rot.y+=rotv;
			}
			
			if(Keyboard.isKeyDown(Keyboard.KEY_UP)){
				camera.rot.x-=rotv;
			}
			if(Keyboard.isKeyDown(Keyboard.KEY_DOWN)){
				camera.rot.x+=rotv;
			}
			
			if(Keyboard.isKeyDown(Keyboard.KEY_P)){
				if(!escDown){
					Game.getInstance().paused = !Game.getInstance().paused;
					if(Game.getInstance().paused){
						Game.getInstance().guiCurrent = Game.getInstance().guiPause;
					}else{
						Game.getInstance().guiCurrent = Game.getInstance().guiGame;
					}
				}
				escDown = true;
			}else{
				
				escDown = false;
			}
			
		}
		
		if(Keyboard.isKeyDown(Keyboard.KEY_M)){
			if(!mDown){
				mute = !mute;
			}
			if(mute){
				mediaLoader.stopAudio(music);
			}else{
				musicStarted = 0l;
			}
			mDown = true;
		}else{
			if(mDown){
			}
			mDown = false;
		}
	}
	boolean mDown = false;
	boolean escDown = false;
	boolean qdown = false;
	boolean edown = false;
	
	public void render(){
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		camera.updateView();
		updateGLLights();
		initGLFog();
		
//		renderOutlineA();
		Game.getInstance().render();
//		renderOutlineB();
//		Game.getInstance().render();
//		renderOutlineC();
	}
	
	int fpsCount;
	long lastCount = 0l;
	int lastfps = 0;
	public void fps(){
		if(lastCount==0l){
			lastCount = System.currentTimeMillis();
		}
		if(System.currentTimeMillis() - lastCount > 1000l){
			lastCount = System.currentTimeMillis();
			lastfps = fpsCount;
			fpsCount = 0;
			L("FPS : " + lastfps);
		}
		fpsCount++;
	}
	
	public void initGL() throws LWJGLException{
		Display.setTitle(NAME + " | Copyright Alastair Breeze 2014");
		Keyboard.create();
		Mouse.create();
		
		glClearColor(1f,1f,1f,1f);
		glClearDepth(1f);
		glViewport(0,0,WIDTH,HEIGHT);
		glEnable(GL_DEPTH_TEST);
		glDepthFunc(GL_LEQUAL);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		camera = new Camera();
		glOrtho(0,WIDTH,0,HEIGHT,-1,1);
		glMatrixMode(GL_MODELVIEW);
		glCullFace(GL_BACK);
		glEnable(GL_CULL_FACE);
		glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
		updateGLLights();
		initGLFog();
		
		sphere = new Sphere();
	}
	
	public void updateGLLights(){
		glShadeModel(GL_SMOOTH);
		
		FloatBuffer pos = BufferUtils.createFloatBuffer(4);
		if(Game.getInstance().player.universe == 1){
			glClearColor(0f,0f,0f,1f);
			pos.put(Game.getInstance().player.pos.x+1.5f*(float)Math.sin(Math.toRadians((double)Game.getInstance().player.rot.y+45f))).put(Game.getInstance().player.pos.y + 1.5f).put(Game.getInstance().player.pos.z+1.5f*(float)Math.cos(Math.toRadians((double)Game.getInstance().player.rot.y+45f))).put(1f).flip();
		}else{
//			glClearColor(0,166f/255f,164f/255f,1f);
			glClearColor(10f/255f,120f/255f,185f/255f,1f);
			pos.put(50f).put(50.5f).put(50f).put(1f).flip();
		}
		glLight(GL_LIGHT0,GL_POSITION,pos);
		
		glEnable(GL_COLOR_MATERIAL);
		glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);
		
		FloatBuffer buf = BufferUtils.createFloatBuffer(4);
		buf.put(0.5f).put(0.5f).put(0.5f).put(1f).flip();
		glLight(GL_LIGHT0,GL_POSITION,pos);
		glMaterial(GL_FRONT, GL_AMBIENT, buf);
		
		buf.clear();
		buf.put(0.5f).put(0.5f).put(0.5f).put(1f).flip();
		glLight(GL_LIGHT0,GL_POSITION,pos);
		glMaterial(GL_FRONT, GL_DIFFUSE, buf);
		buf.clear();
		
		glMaterialf(GL_FRONT, GL_SHININESS, 50f);
	}
	
	public void initGLFog(){
		glEnable(GL_FOG);
		FloatBuffer fog = BufferUtils.createFloatBuffer(4);
		if(Game.getInstance().player.universe == 1){
			fog.put(0f).put(0f).put(0f).put(1f).flip();
			glFogf(GL_FOG_DENSITY,0.05f);
		}else{
//			fog.put(0.95f).put(0.95f).put(0.95f).put(1f).flip();
			fog.put(125f/255f).put(197f/255f).put(217f/255f).put(1f).flip();
			glFogf(GL_FOG_DENSITY,0.025f);
		}
		glFogi(GL_FOG_MODE,GL_EXP);
		glFog(GL_FOG_COLOR,fog);
		
		glHint(GL_FOG_HINT,GL_DONT_CARE);
		glFogf(GL_FOG_START,15f);
		glFogf(GL_FOG_END,35f);
	}
	
//	LISTS
	public static int startList(){
		int i = glGenLists(1);
		glNewList(i,GL_COMPILE);
		return i;
	}
	
	public static void restartList(int i){
		glNewList(i,GL_COMPILE);
	}
	
	public static void endList(){
		glEndList();
	}
	
	public static void renderList(int i){
		glCallList(i);
	}
	
	public static void renderOutlineList(int i){
		renderOutlineA();
		glCallList(i);
		renderOutlineB();
		glCallList(i);
		renderOutlineC();
	}
	
	public static void renderOutlineA(){
		glLineWidth(2f);
		glPolygonOffset(1f,1f);
		glEnable(GL_POLYGON_OFFSET_FILL);
	}
	
	public static void renderOutlineB(){
		glDisable(GL_POLYGON_OFFSET_FILL);
		glDisable(GL_LIGHT0);
		glColor3f(0f,0f,0f);
		glPolygonMode(GL_FRONT,GL_LINE);
	}
	
	public static void renderPoint(Vec3 p, int col){
		renderPoint(p, 2f, col);
	}
	
	public static void renderPoint(Vec3 p, float w, int col){
		glPointSize(w);
		glBegin(GL_POINTS);
		color3f(col);
		glVertex3f(p.x,p.y,p.z);
		glEnd();
	}

	public static void renderOutlineC(){
		glEnable(GL_LIGHT0);
		glPolygonMode(GL_FRONT,GL_FILL);
	}
	
	public static void renderSphere(Vec3 pos, float rad, int lev){
		glDisable(GL_CULL_FACE);
		glPushMatrix();
		{
			Mesh.translate(pos, new Vec3());
			
			sphere.draw(rad,lev,lev);
			
			glEnd();
		}
		glPopMatrix();
		glEnable(GL_CULL_FACE);
	}
	
	public static void color3f(int col){
		glColor3f((float)((col>>16)&0xFF)/255f, (float)((col>>8)&0xFF)/255f, (float)((col)&0xFF)/255f);
	}
}
