package com.alastairbreeze.connectedworlds.Engine;

public class SoundManager {

	private static SoundManager sm;
	
	public static SoundManager getInstance(){
		if(sm==null){
			sm = new SoundManager();
			sm.init();
		}
		return sm;
	}
	
	int upWorldSound = -1;
	int downWorldSound = -1;
	int pickupSound = -1;
	int hurtSound = -1;
	public void init(){
		downWorldSound = Core.c.mediaLoader.getAudio("downworld.au");
		upWorldSound = Core.c.mediaLoader.getAudio("upworld.au");
		pickupSound = Core.c.mediaLoader.getAudio("pickup.au");
		hurtSound = Core.c.mediaLoader.getAudio("hurt.au");
	}
	
	public void playUpWorldSound(){
		Core.c.mediaLoader.playAudio(upWorldSound);
	}
	
	public void playDownWorldSound(){
		Core.c.mediaLoader.playAudio(downWorldSound);
	}
	
	public void playPickupSound(){
		Core.c.mediaLoader.playAudio(pickupSound);
	}
	
	public void playHurtSound(){
		Core.c.mediaLoader.playAudio(hurtSound);
	}
}
