package com.alastairbreeze.connectedworlds.Entities;

import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.SoundManager;
import com.alastairbreeze.connectedworlds.Meshes.Cube;

public class Entity {

	public Vec3 pos = new Vec3();
	public Vec3 rot = new Vec3();
	public int universe = -1;
	public boolean alive = true;
	public boolean important = false;
	public boolean good = true;
	
	public float scale = 1f;
	
//	BOX
	public float height = 3f;
	public float rad = 0.55f;
	
	private long lastSwitch = 0l;
	public long switchInterval = 5000l;
	
	public Entity(){

	}
	
	public void init(){
		
	}
	
	public void update(){
		
	}
	
	public void render(){
		glPushMatrix();
		{
			if(System.currentTimeMillis() - lastSwitch < 250l){
				float size = (float)(System.currentTimeMillis() - lastSwitch)/25f;
				Cube.render(Vec3.add(pos, new Vec3(0f,height + 0.6f,0f)), new Vec3(size,size,size),new Vec3(rot.x,-Core.c.camera.rot.y,rot.z), 0xffffff);
			}
		}
		glPopMatrix();
	}
	
	public void die(){
		
	}

	public void switchUniverse(){
//		if(System.currentTimeMillis() - lastSwitch > switchInterval){
			universe = 1 - universe;
			lastSwitch = System.currentTimeMillis();
			if(universe==1){
				SoundManager.getInstance().playUpWorldSound();
			}else{
				SoundManager.getInstance().playDownWorldSound();
			}
//		}
	}
}
