package com.alastairbreeze.connectedworlds.Entities;

import static org.lwjgl.opengl.GL11.GL_LIGHTING;
import static org.lwjgl.opengl.GL11.glDisable;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Entities.Items.EntityItem;
import com.alastairbreeze.connectedworlds.Entities.Items.EntityItemHand;
import com.alastairbreeze.connectedworlds.Meshes.Cube;
import com.alastairbreeze.connectedworlds.Meshes.Mesh;

public class EntityBear extends EntityAlive{

	int headList = -1;
	int bodyList = -1;
	
	public int skin = 0x6B2900;
	public int extras = 0x6B4D2D;
	
	public EntityBear(){
		super();
		health = 150;
		maxHealth = 150;
		moveSpeed = 0.004f;
	}
	
	public void init(){
		super.init();
		EntityItemHand eih = new EntityItemHand();
		eih.pow = 8f;
		eih.reuseTime*=4l;
		hold(eih);
		if(headList == -1){
			headList = Core.startList();
			Cube.render(new Vec3(0f*scale,2.5f*scale,0f*scale), new Vec3(0.8f*scale,0.8f*scale,0.6f*scale),skin);
			Cube.render(new Vec3(0.0f*scale,2.6f*scale,0.3f*scale), new Vec3(0.4f*scale,0.2f*scale,0.05f*scale),0xFFFFFF);
			Cube.render(new Vec3(0.1f*scale,2.6f*scale,0.31f*scale), new Vec3(0.1f*scale,0.1f*scale,0.05f*scale),0x00);
			Cube.render(new Vec3(-0.1f*scale,2.6f*scale,0.31f*scale), new Vec3(0.1f*scale,0.1f*scale,0.05f*scale),0x00);
			Cube.render(new Vec3(0f*scale,2.3f*scale,0.3f*scale), new Vec3(0.3f*scale,0.2f*scale,0.05f*scale),extras);
//			Cube.render(new Vec3(0.0f*scale,-2f*scale,0.48f*scale), new Vec3(0.8f*scale,0.01f*scale,0.05f*scale),0x00);
//			EARS
			Cube.render(new Vec3(-0.4f*scale,2.9f*scale,0f*scale), new Vec3(0.3f*scale,0.3f*scale,0.1f*scale),new Vec3(0f,0f,45f),skin);
			Cube.render(new Vec3(-0.4f*scale,2.9f*scale,0.05f*scale), new Vec3(0.1f*scale,0.1f*scale,0.05f*scale),new Vec3(0f,0f,45f),0xFF6AC5);
			Cube.render(new Vec3(0.4f*scale,2.9f*scale,0f*scale), new Vec3(0.3f*scale,0.3f*scale,0.1f*scale),new Vec3(0f,0f,45f),skin);
			Cube.render(new Vec3(0.4f*scale,2.9f*scale,0.05f*scale), new Vec3(0.1f*scale,0.1f*scale,0.05f*scale),new Vec3(0f,0f,45f),0xFF6AC5);
	//		NECK	
			Cube.render(new Vec3(0f*scale,2f*scale,0f*scale), new Vec3(0.4f*scale,0.5f*scale,0.4f*scale),skin);
			Core.endList();
		}
		if(bodyList == -1){
			bodyList = Core.startList();
			Cube.render(new Vec3(0f*scale,1.25f*scale,0f*scale), new Vec3(1.2f*scale,1.4f*scale,0.8f*scale),skin);
			Cube.render(new Vec3(0f*scale,1.85f*scale,0f*scale), new Vec3(2.1f*scale,0.4f*scale,0.4f*scale),skin);
			Cube.render(new Vec3(0f*scale,1.25f*scale,0.4f*scale), new Vec3(0.6f*scale,0.8f*scale,0.1f*scale),extras);
			Core.endList();
		}
	}
	
	public void update(){
		super.update();
	}
	
	public void die(){
		super.die();
		Game.getInstance().particleExplosion(new Vec3(pos.x,pos.y+height/2,pos.z), 0xff0000, 1f);
	}
	
	public void render(){
		super.render();
		glPushMatrix();
		{
			Mesh.translate(pos, rot);
			
			
	//		
			
			float mag = vel.getMagXZ();
			float cycle = 200*mag*(float)Math.cos(Math.toRadians((double)Game.getInstance().cycle)*16f);
			float cycle2 = 200*mag*(float)Math.cos(Math.toRadians((double)Game.getInstance().cycle)*8f);
			glPushMatrix();
			{
				Mesh.translate(new Vec3(), new Vec3(cycle/5f,cycle2/3f,0f));
				Core.renderList(headList);
			}
			glPopMatrix();
			Core.renderList(bodyList);
			
			
	//		RIGHT ARM
			glPushMatrix();
			{
				float ex = 0f;
				float mult = 2f;

				Mesh.translate(new Vec3(0.85f*scale,1.8f*scale,0f*scale), new Vec3(-cycle*mult+ex,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.3f*scale,0f*scale), new Vec3(0.4f*scale,0.6f*scale,0.4f*scale),skin);

			}
			glPopMatrix();
	//		LEFT ARM
			glPushMatrix();
			{
				float ex = 0f;
				float mult = 2f;
				if(currentItem!=null && !(currentItem instanceof EntityItemHand)){
					ex = -60f;
					mult = 0.2f;
					ex+=90f*attackAni;
				}else{
					ex-=90f*attackAni;
				}
				
				Mesh.translate(new Vec3(-0.85f*scale,1.8f*scale,0f*scale), new Vec3(cycle*mult+ex,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.3f*scale,0f*scale), new Vec3(0.4f*scale,0.6f*scale,0.4f*scale),skin);
				
				if(currentItem!=null){
					Mesh.translate(new Vec3(-0.0f,-1.3f,0.2f), new Vec3(0f,90f,0f));
					currentItem.attackAni = attackAni;
					currentItem.render();
				}
			}
			glPopMatrix();
	//		RIGHT LEG
			glPushMatrix();
			{
				Mesh.translate(new Vec3(-0.25f*scale,0.5f*scale,0f*scale), new Vec3(cycle*2f,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.21f*scale,0f*scale), new Vec3(0.4f*scale,0.65f*scale,0.4f*scale),skin);
			}
			glPopMatrix();
	//		LEFT LEG
			glPushMatrix();
			{
				Mesh.translate(new Vec3(0.25f*scale,0.5f*scale,0f*scale), new Vec3(-cycle*2f,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.21f*scale,0f*scale), new Vec3(0.4f*scale,0.65f*scale,0.4f*scale),skin);
			}
			glPopMatrix();
		}
		glPopMatrix();
	}
}