package com.alastairbreeze.connectedworlds.Entities;

import static org.lwjgl.opengl.GL11.GL_LIGHTING;
import static org.lwjgl.opengl.GL11.glDisable;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Entities.Items.EntityItemHand;
import com.alastairbreeze.connectedworlds.Meshes.Cube;
import com.alastairbreeze.connectedworlds.Meshes.Mesh;

public class EntityHuman extends EntityAlive{

	int headList = -1;
	int bodyList = -1;
	
	public int skin = 0xFFC7C5;
	public int clothes = 0x67CDFF;
	public int legs = 0xFFFFFF;
	
	public EntityHuman(){
		super();
		health = 100;
		maxHealth = 100;
	}
	
	public void init(){
		super.init();
		if(headList == -1){
			headList = Core.startList();
//			HAT
			Cube.render(new Vec3(0f*scale,0.8f*scale,0f*scale), new Vec3(1.05f*scale,0.3f*scale,1.05f*scale),clothes);
			Cube.render(new Vec3(0f*scale,0.8f*scale,0f*scale), new Vec3(1.05f*scale,0.3f*scale,1.05f*scale),clothes);
			Cube.render(new Vec3(0f*scale,0.7f*scale,0.2f*scale), new Vec3(1.02f*scale,0.05f*scale,1.45f*scale),clothes);
			//HEAD
			Cube.render(new Vec3(0f*scale,0.2f*scale,0f*scale), new Vec3(1f*scale,1f*scale,1f*scale),skin);
			Cube.render(new Vec3(0.0f*scale,0.3f*scale,0.53f*scale), new Vec3(0.8f*scale,0.2f*scale,0.05f*scale),0xFFFFFF);
			Cube.render(new Vec3(0.2f*scale,0.3f*scale,0.54f*scale), new Vec3(0.1f*scale,0.1f*scale,0.05f*scale),0x00);
			Cube.render(new Vec3(-0.2f*scale,0.3f*scale,0.54f*scale), new Vec3(0.1f*scale,0.1f*scale,0.05f*scale),0x00);
			Cube.render(new Vec3(0.0f*scale,-0.1f*scale,0.48f*scale), new Vec3(0.8f*scale,0.01f*scale,0.05f*scale),0x00);
			Core.endList();
		}
		if(bodyList == -1){
			bodyList = Core.startList();
	//		NECK	
			Cube.render(new Vec3(0f*scale,1.6f*scale,0f*scale), new Vec3(0.2f*scale,0.5f*scale,0.2f*scale),skin);
	//		BODY
			Cube.render(new Vec3(0f*scale,1f*scale,0f*scale), new Vec3(0.5f*scale,1f*scale,0.3f*scale),clothes);
			Cube.render(new Vec3(0f*scale,1.35f*scale,0f*scale), new Vec3(1.2f*scale,0.2f*scale,0.24f*scale),clothes);
			Core.endList();
		}
	}
	
	public void update(){
		super.update();
	}
	
	public void die(){
		super.die();
		Game.getInstance().particleExplosion(new Vec3(pos.x,pos.y+height/2,pos.z), 0xff0000, 1f);
	}
	
	public void render(){
		super.render();
		glPushMatrix();
		{
			Mesh.translate(pos, rot);
			float mag = vel.getMagXZ();
			float cycle = 200*mag*(float)Math.cos(Math.toRadians((double)Game.getInstance().cycle)*16f);
			float cycle2 = 200*mag*(float)Math.cos(Math.toRadians((double)Game.getInstance().cycle)*8f);
			glPushMatrix();
			{
				Mesh.translate(new Vec3(0f*scale,2f*scale,0f*scale), new Vec3(cycle/5f,cycle2/3f,0f));
				Core.renderList(headList);
			}
			glPopMatrix();
			Core.renderList(bodyList);
			
			
	//		RIGHT ARM
			glPushMatrix();
			{
				float ex = 0f;
				float mult = 1f;
				if(Game.getInstance().player.universe == 1 && this == Game.getInstance().player){
					ex = -60f;
					mult = 0.2f;
				}
				Mesh.translate(new Vec3(0.45f*scale,1.3f*scale,0f*scale), new Vec3(-cycle*mult+ex,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.3f*scale,0f*scale), new Vec3(0.2f*scale,0.6f*scale,0.2f*scale),skin);
				if(Game.getInstance().player.universe == 1 && this == Game.getInstance().player){
					Cube.render(new Vec3(0f*scale,-0.6f*scale,0.10f*scale), new Vec3(0.1f*scale,0.6f*scale,0.1f*scale),new Vec3(90f,0f,0f),skin);
					glDisable(GL_LIGHTING);
					Cube.render(new Vec3(0f*scale,-0.6f*scale,0.40f*scale), new Vec3(0.15f*scale,0.15f*scale,0.15f*scale),new Vec3(90f,0f,0f),0xE8CB4A);
					glEnable(GL_LIGHTING);
				}

			}
			glPopMatrix();
	//		LEFT ARM
			glPushMatrix();
			{
				float ex = 0f;
				float mult = 1f;
				if(currentItem!=null && !(currentItem instanceof EntityItemHand)){
					ex = -60f;
					mult = 0.2f;
					ex+=90f*attackAni;
				}else{
					ex-=90f*attackAni;
				}
				
				Mesh.translate(new Vec3(-0.45f*scale,1.3f*scale,0f*scale), new Vec3(cycle*mult+ex,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.3f*scale,0f*scale), new Vec3(0.2f*scale,0.6f*scale,0.2f*scale),skin);
				
				if(currentItem!=null){
					Mesh.translate(new Vec3(-0.0f,-1.3f,0.2f), new Vec3(0f,90f,0f));
					currentItem.attackAni = attackAni;
					currentItem.render();
				}
			}
			glPopMatrix();
	//		RIGHT LEG
			glPushMatrix();
			{
				Mesh.translate(new Vec3(-0.1f*scale,0.5f*scale,0f*scale), new Vec3(cycle,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.21f*scale,0f*scale), new Vec3(0.2f*scale,0.65f*scale,0.2f*scale),legs);
			}
			glPopMatrix();
	//		LEFT LEG
			glPushMatrix();
			{
				Mesh.translate(new Vec3(0.1f*scale,0.5f*scale,0f*scale), new Vec3(-cycle,0f,0f));
				Cube.render(new Vec3(0f*scale,-0.21f*scale,0f*scale), new Vec3(0.2f*scale,0.65f*scale,0.2f*scale),legs);
			}
			glPopMatrix();
		}
		glPopMatrix();
	}
}
