package com.alastairbreeze.connectedworlds.Entities;

import static org.lwjgl.opengl.GL11.GL_LIGHTING;
import static org.lwjgl.opengl.GL11.glDisable;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Entities.Items.EntityItemHand;
import com.alastairbreeze.connectedworlds.Meshes.Cube;
import com.alastairbreeze.connectedworlds.Meshes.Mesh;

public class EntityRat extends EntityAlive{

	int list = -1;
	
	int skin = 0xFFC7C5;
	
	public EntityRat(){
		super();
		health = 60;
		maxHealth = 60;
		height = 1f;
		important=true;
		runScale = 3f;
		moveSpeed = 0.012f;
	}
	
	public void init(){
		super.init();
		EntityItemHand eih = new EntityItemHand();
		eih.pow = 1f;
		eih.reuseTime*=4l;
//		if(list == -1){
//			list = Core.startList();
//			Core.endList();
//		}
	}
	
	public void update(){
		super.update();
		
		randTarget();
		
		followTarget();
	}
	
	public void die(){
		super.die();
		Game.getInstance().particleExplosion(new Vec3(pos.x,pos.y+height/2,pos.z), 0xff0000, 1f);
	}
	
	public void render(){
		super.render();
		glPushMatrix();
		{
			Mesh.translate(pos, rot);
			float mag = vel.getMagXZ();
			float cycle = 200*mag*(float)Math.cos((double)System.currentTimeMillis()/45);
			float cycle2 = 200*mag*(float)Math.cos((double)System.currentTimeMillis()/90);
//			Core.renderList(list);
			
			Cube.render(new Vec3(0f,0.2f,0f), new Vec3(0.3f,0.2f,0.6f),skin);
			Cube.render(new Vec3(0.0f,0.2f,0.33f), new Vec3(0.3f,0.1f,0.05f),0xFFFFFF);
			Cube.render(new Vec3(0.1f,0.2f,0.34f), new Vec3(0.05f,0.05f,0.05f),0x00);
			Cube.render(new Vec3(-0.1f,0.2f,0.34f), new Vec3(0.05f,0.05f,0.05f),0x00);
	//		RIGHT ARM
			Mesh.translate(new Vec3(0.1f,0.5f,0f), new Vec3(-cycle,0f,0f));
			glPopMatrix();
		}
		glPopMatrix();
	}
}
