package com.alastairbreeze.connectedworlds.Entities;

import static org.lwjgl.opengl.GL11.GL_LIGHTING;
import static org.lwjgl.opengl.GL11.glDisable;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Entities.Items.EntityItemHand;
import com.alastairbreeze.connectedworlds.Meshes.Cube;
import com.alastairbreeze.connectedworlds.Meshes.Mesh;

public class EntityTree extends Entity{

	public float treeheight = 4f;
	int uni1lst = -1;
	int uni2lst = -1;
	
	public void init(){
		treeheight = 4f + (float)(int)(Game.getInstance().rand.nextFloat()*3f);
		uni1lst = Core.startList();
		glPushMatrix();
		{
			Mesh.translate(pos, rot);
//			Mesh.translate(new Vec3(0.1f,0.5f,0f), new Vec3(-0,0f,0f));
			Cube.render(new Vec3(0f,treeheight/2,0f), new Vec3(1f,treeheight,1f),0x5C4537);
			int radiu = 3;
			float minu = -1f;
			if(treeheight>5f){
				radiu = 4;
				minu = -1.5f;
			}
			for(int i=0;i<radiu;i++){
				for(int j=0;j<radiu;j++){
					for(int k=0;k<radiu;k++){
//						if(Game.getInstance().rand.nextFloat() < 0.8f){
							int col = 0;
							int p = Game.getInstance().rand.nextInt(4);
							if(p == 0){
								col = 0x00752E;
							}else if(p==1){
								col = 0x548C27;
							}else if(p==2){
								col = 0xADDE73;
							}else if(p==3){
								col = 0x1D7539;
							}
							Cube.render(new Vec3(minu+(float)i,treeheight+(float)j,minu+(float)k), new Vec3(1f,1f,1f),new Vec3(Game.getInstance().rand.nextFloat()*90f,0f,Game.getInstance().rand.nextFloat()*90f),col);
//						}
					}
				}
			}
//			Cube.render(new Vec3(0f,8f,0f), new Vec3(3f,3f,3f),0x00ff00);
//			Cube.render(new Vec3(0f,2.21f,0f), new Vec3(1f,1f,1f),0x00);
		}
		glPopMatrix();
		Core.endList();
		uni2lst = Core.startList();
		glPushMatrix();
		{
			Mesh.translate(pos, rot);
//			Mesh.translate(new Vec3(0.1f,0.5f,0f), new Vec3(-0,0f,0f));
			Cube.render(new Vec3(0f,treeheight/2,0f), new Vec3(1f,treeheight,1f),0x5C4537);
			int radiu = 3;
			float minu = -1f;
			if(treeheight>5f){
				radiu = 4;
				minu = -1.5f;
			}
			for(int i=0;i<radiu;i++){
				for(int j=0;j<radiu;j++){
					for(int k=0;k<radiu;k++){
//						if(Game.getInstance().rand.nextFloat() < 0.8f){
							int col = 0;
							int p = Game.getInstance().rand.nextInt(4);
							if(p == 0){
								col = 0x5C150C;
							}else if(p==1){
								col = 0x9C1907;
							}else if(p==2){
								col = 0x9C163D;
							}else if(p==3){
								col = 0x9C4252;
							}
							Cube.render(new Vec3(minu+(float)i,treeheight+(float)j,minu+(float)k), new Vec3(1f,1f,1f),new Vec3(Game.getInstance().rand.nextFloat()*90f,0f,Game.getInstance().rand.nextFloat()*90f),col);
//						}
					}
				}
			}
//			Cube.render(new Vec3(0f,8f,0f), new Vec3(3f,3f,3f),0x00ff00);
//			Cube.render(new Vec3(0f,2.21f,0f), new Vec3(1f,1f,1f),0x00);
		}
		glPopMatrix();
		Core.endList();
	}
	
	public void render(){
		super.render();
		if(Game.getInstance().player.universe == 0){
			Core.renderList(uni1lst);
		}else{
			Core.renderList(uni2lst);
		}
	}
}
