package com.alastairbreeze.connectedworlds.Entities.Items;

import static org.lwjgl.opengl.GL11.GL_LIGHTING;
import static org.lwjgl.opengl.GL11.glDisable;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Engine.SoundManager;
import com.alastairbreeze.connectedworlds.Entities.EntityAlive;
import com.alastairbreeze.connectedworlds.Meshes.Cube;
import com.alastairbreeze.connectedworlds.Meshes.Mesh;

public class EntityItem extends EntityAlive{
	
	long startTime = 0l;
	long ttl = 0l;
	public boolean used = false;
	public boolean repeatable = true;
	public long reuseTime = 250l;
	public float range = 1.5f;

	public EntityItem(){
		super();
		startTime = System.currentTimeMillis();
		rad = 0.1f;
	}
	
	public void init(){
		
	}
	
	public void update(){
		super.update();
	}
	
	public void render(){
		glPushMatrix();
		{
			float cycle = (System.currentTimeMillis()/10%360);
			if(!alive)cycle = 0;
			Cube.render(new Vec3(pos.x,pos.y+0.7f,pos.z), new Vec3(0.4f,0.4f,0.4f), new Vec3(0f,cycle,0f),0x00fff0);
		}
		glPopMatrix();
	}
	
	public void pickup(EntityAlive e){
		alive = false;
		e.hold(this);
		pos = new Vec3();
		SoundManager.getInstance().playPickupSound();
	}
	
	public void use(EntityAlive e){
		
	}
	
	public void collide(){
		Core.L("");
	}
	
	public String getName(){
		return "Unknown";
	}
}
