package com.alastairbreeze.connectedworlds.Entities.Items;

import static org.lwjgl.opengl.GL11.glPopMatrix;
import static org.lwjgl.opengl.GL11.glPushMatrix;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Entities.Entity;
import com.alastairbreeze.connectedworlds.Entities.EntityAlive;
import com.alastairbreeze.connectedworlds.Meshes.Cube;

public class EntityItemSwapper extends EntityItem{
	
	public EntityItemSwapper(){
		super();
		repeatable = false;
		reuseTime = 3000l;
		range = 2.5f;
	}
	
	public void render(){
		glPushMatrix();
		{
			float cycle = Game.getInstance().cycle;
			if(!alive)cycle = 0;
//			Mesh.translate(new Vec3(), new Vec3(0f,cycle,0f));
			float ex = (float)Math.sin(Math.toRadians((double)cycle));
			Cube.render(new Vec3(pos.x-0.2f,pos.y+0.7f,pos.z), new Vec3(1f,0.1f,0.1f), new Vec3(0f,0f,0f),0x98FFD5);
			Cube.render(new Vec3(pos.x-1.5f+ex/3f - attackAni*10f,pos.y+0.7f,pos.z), new Vec3(0.3f,0.3f+ex/5,0.3f), new Vec3(cycle,cycle,cycle),0xffffff);
		}
		glPopMatrix();
	}
	
	public void use(EntityAlive e){
		super.use(e);
		e.attack(1f*e.scale);
		Entity front = e.getEntityInfront(6f);
		if(front!=null){
			front.switchUniverse();
		}
		e.switchUniverse();
	}
	
	
	public String getName(){
		return "Switcher";
	}
}
