package com.alastairbreeze.connectedworlds.Meshes;

//import java.awt.Color;

import static org.lwjgl.opengl.GL11.*;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;

public class Cube extends Mesh{
	
	public void render(){
		render(pos,dim,rot);
	}
	
	public static void render(Vec3 p, Vec3 d){
		render(p,d,new Vec3(),0xffffff);
	}
	
	public static void render(Vec3 p, Vec3 d, int col){
		render(p,d,new Vec3(),col);
	}
	
	public static void render(Vec3 p, Vec3 d, Vec3 r){
		render(p,d,r,0xffffff);
	}
	
	public static void render(Vec3 p, Vec3 d, Vec3 r, int col){
		glPushMatrix();
		{
			translate(p,r);
			
			glBegin(GL_QUADS);
			{
				renderer(p,d,r,col);
			}
			glEnd();
		}
		glPopMatrix();
	}

	public static void renderer(Vec3 p, Vec3 d, Vec3 r, int col){
		Core.color3f(col);
		
		float wid = d.x/2f;
		float hei = d.y/2f;
		float dep = d.z/2f;
		
		glNormal3f(0f,0f,1f);
		glVertex3f(wid,-hei,dep);
		glVertex3f(wid,hei,dep);
		glVertex3f(-wid,hei,dep);
		glVertex3f(-wid,-hei,dep);
		
		glNormal3f(0f,0f,-1f);
		glVertex3f(-wid,-hei,-dep);
		glVertex3f(-wid,hei,-dep);
		glVertex3f(wid,hei,-dep);
		glVertex3f(wid,-hei,-dep);
		
		glNormal3f(-1f,0f,0f);
		glVertex3f(-wid,-hei,-dep);
		glVertex3f(-wid,-hei,dep);
		glVertex3f(-wid,hei,dep);
		glVertex3f(-wid,hei,-dep);
		
		glNormal3f(1f,0f,0f);
		glVertex3f(wid,-hei,dep);
		glVertex3f(wid,-hei,-dep);
		glVertex3f(wid,hei,-dep);
		glVertex3f(wid,hei,dep);
		
		glNormal3f(0f,-1f,0f);
		glVertex3f(-wid,-hei,-dep);
		glVertex3f(wid,-hei,-dep);
		glVertex3f(wid,-hei,dep);
		glVertex3f(-wid,-hei,dep);
		
		glNormal3f(0f,1f,0f);
		glVertex3f(-wid,hei,dep);
		glVertex3f(wid,hei,dep);
		glVertex3f(wid,hei,-dep);
		glVertex3f(-wid,hei,-dep);
	}
}
