package com.alastairbreeze.connectedworlds;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.Image;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

import com.alastairbreeze.connectedworlds.Engine.Core;

public class StartFrame extends Frame implements MediaLoader{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	ArrayList<Clip> audios = new ArrayList<Clip>();
	
	public static void main(String[] args){
		StartFrame sf = new StartFrame();
		sf.init();
		sf.start();
//		sf.stop();
//		sf.destroy();
	}

	public void init(){
		Core.L("Starting Frame");
		setLayout(new BorderLayout());
		Core.c = new Core(this);
		Core.c.init();
		add(Core.c.display);
		Core.c.initOther();
		
		setSize(Core.WIDTH, Core.HEIGHT);
		setResizable(false);
		
		setVisible(true);
		
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent we){
				stop();
				destroy();
			}
		});
	}
	
	public void start(){
		
	}
	
	public void stop(){
		
	}
	
	public void destroy(){
		remove(Core.c.display);
//		super.destroy();
		System.exit(0);
	}

	public int getAudio(String name) {
		try {
			Clip c = AudioSystem.getClip();
//			AudioInputStream in = AudioSystem.getAudioInputStream();
			InputStream bufin = new BufferedInputStream(getClass().getResourceAsStream("/res/"+name));
			AudioInputStream in = AudioSystem.getAudioInputStream(bufin);
			c.open(in);
			audios.add(c);
			return audios.size()-1;
		} catch (UnsupportedAudioFileException | IOException e) {
			e.printStackTrace();
		} catch (LineUnavailableException e) { 
			e.printStackTrace();
		}
		return -1;
	}
	
	public void playAudio(int i){
		if(i>=0 && i<audios.size()){
			audios.get(i).setFramePosition(0);
			audios.get(i).start();
		}
	}
	
	public void stopAudio(int i){
		if(i>=0 && i<audios.size()){
			audios.get(i).setFramePosition(0);
			audios.get(i).stop();
//			audios.get(i).start();
		}
	}

	public Image getImage(String name) {
		return null;
	}
}
