package com.alastairbreeze.connectedworlds;

public class Vec3 {

	public float x,y,z;
	
	public Vec3(){
		x=0f;
		y=0f;
		z=0f;
	}
	
	public Vec3(Vec3 v){
		x = v.x;
		y = v.y;
		z = v.z;
	}
	
	public Vec3(float x1, float y1, float z1){
		x = x1;
		y = y1;
		z = z1;
	}
	
	public Vec3(Vec3 from, Vec3 to){
		x = to.x-from.x;
		y = to.y-from.y;
		z = to.z-from.z;
	}
	
	public void add(Vec3 vec){
		x += vec.x;
		y += vec.y;
		z += vec.z;
	}
	
	public static Vec3 add(Vec3 a, Vec3 b){
		return new Vec3(a.x+b.x,a.y+b.y,a.z+b.z);
	}
	
	public void subtract(Vec3 vec){
		x -= vec.x;
		y -= vec.y;
		z -= vec.z;
	}
	
	public void scale(float f){
		x *= f;
		y *= f;
		z *= f;
	}
	
	public static float dot(Vec3 a, Vec3 b){
		return a.x*b.x + a.y*b.y + a.z*b.z;
	}
	
	public float getMag(){
		return (float)Math.sqrt((double)(x*x+y*y+z*z));
	}
	
	public float getMagXZ(){
		return (float)Math.sqrt((double)(x*x+z*z));
	}
	
	public static float getDist(Vec3 a, Vec3 b){
		Vec3 c = new Vec3(a,b);
		return c.getMag();
	}
	
	public Vec3 clone(){
		return new Vec3(this);
	}
	
	public String toString(){
		return "(" + x + "," + y + "," + z + ")";
	}
	
	public Vec3 getReverse(){
		return new Vec3(-x,-y,-z);
	}
	
	public void normalize(){
		float m = getMag();
		x /= m;
		y /= m;
		z /= m;
	}
	
	public Vec3 getNormalized(){
		float m = getMag();
		return new Vec3(x /= m,y /= m,z /= m);
	}
}
