package com.alastairbreeze.connectedworlds.Worlds;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Meshes.Cube;

public class Zone {
	
	Vec3 pos = new Vec3();
	int width = 20;
	int height = 20;
	int u1listID = -1;
	int u2listID = -1;
	float[] heights = new float[width*height];
	
	public float getHeight(int x, int z){
		if(x >= 0 && x < width && z >= 0 && z < height){
			return heights[x + z*height];
		}
		return 0f;
	}
	
	public void setHeight(int x, int z, float v){
		heights[x + z*height] = v;
	}
	
	public void init(){
		for(int x=0;x<width;x++){
			for(int z=0; z<height; z++){
				setHeight(x,z,Game.getInstance().rand.nextFloat()*1f);
			}
		}
		createLists();
	}
	
	public void createLists(){
		u1listID = Core.startList();
		createZone(0);
		Core.endList();
		u2listID = Core.startList();
		createZone(1);
		Core.endList();
	}
	
	public void createZone(int i){
		for(int x=0;x < 20;x++){
			for(int z=0;z<20;z++){
				int col = 0x599918;
				if(i == 1){
					col = 0x992122;
				}
				Cube.render(new Vec3((float)x,getHeight(x,z)-0.5f,(float)z), new Vec3(1f,1f,1f),col);
			}
		}
	}
	
	public void render(){
		if(Game.getInstance().player.universe == 0){
			Core.renderList(u1listID);
		}else{
			Core.renderList(u2listID);
		}
	}
}
