package com.alastairbreeze.connectedworlds.Worlds;

import com.alastairbreeze.connectedworlds.Vec3;
import com.alastairbreeze.connectedworlds.Engine.Core;
import com.alastairbreeze.connectedworlds.Engine.Game;
import com.alastairbreeze.connectedworlds.Meshes.Cube;
import static org.lwjgl.opengl.GL11.*;
public class ZoneIsland extends Zone{
	
	Vec3 pos = new Vec3();
	int width = 100;
	int height = 100;
	int u1listID = -1;
	int u2listID = -1;
	float[] heights = new float[width*height];
	
	public float getHeight(int x, int z){
		if(x >= 0 && x < width && z >= 0 && z < height){
			if(heights[x + z*height]>-0.5){
				return heights[x + z*height];
			}else{
				return -0.5f;
			}
		}
		return 0f;
	}
	
	public void setHeight(int x, int z, float v){
		heights[x + z*height] = v;
	}
	
	public void init(){
		float ran1 = Game.getInstance().rand.nextFloat();
		float ran2 = Game.getInstance().rand.nextFloat();
		float ran3 = Game.getInstance().rand.nextFloat();
		for(int x=0;x<width;x++){
			for(int z=0; z<height; z++){
				float dist = new Vec3(new Vec3((float)x-50f,0f,(float)z-50f), new Vec3(0f,0f,0f)).getMag();
				float ex = 1f*(float)Math.sin(Math.toRadians((double)(x/100f*180f)))-0.5f;
				ex+=3f*(float)Math.sin(Math.toRadians((double)(x/100f*180f + ran1*45f))) - 1.5f;
				ex+=3f*(float)Math.sin(Math.toRadians((double)(z/100f*180f + ran2*45f))) - 1.5f;
				ex+=1f*(float)Math.sin(Math.toRadians((double)(z/100f*1000f + ran2*45f))) - 0.5f;
				ex+=1f*(float)Math.sin(Math.toRadians((double)(x/100f*1000f + ran2*450f - 250f))) - 0.5f;
				setHeight(x,z,- dist/8f +6.25f + Game.getInstance().rand.nextFloat()/4f - 1f/8f + ex);
			}
		}
		createLists();
	}
	
	public void createLists(){
		u1listID = Core.startList();
		createZone(0);
		Core.endList();
		u2listID = Core.startList();
		createZone(1);
		Core.endList();
	}
	
	public void createZone(int i){
		if(i==0){
//			glDisable(GL_FOG);
			glDisable(GL_LIGHTING);
			Cube.render(new Vec3(0f,0,0f), new Vec3(2000f,1f,2000f),0x0090C7);
//			glEnable(GL_FOG);
			glEnable(GL_LIGHTING);
		}else{
			glDisable(GL_LIGHTING);
			Cube.render(new Vec3(0f,0,0f), new Vec3(2000f,1f,2000f),0xFF360C);
			glEnable(GL_LIGHTING);
		}
		for(int x=0;x < 100;x++){
			for(int z=0;z<100;z++){
				float t = Game.getInstance().rand.nextFloat();
				int col=0;
				if(t < 0.25f){
					col = 0xD4AE16;
				}else if (t < 0.5f){
					col = 0xD4BD1D;
				}else if (t < 0.75f){
					col = 0xD4D012;
				}else{
					col = 0xD4CD3D;
				}
				if(i == 0){
					float dist = new Vec3(new Vec3((float)x-50f,0f,(float)z-50f), new Vec3(0f,0f,0f)).getMag();
					if(dist < 35f + 5f*Game.getInstance().rand.nextFloat() &&  getHeight(x,z) > 1f+Game.getInstance().rand.nextFloat()*2f){
						float l = Game.getInstance().rand.nextFloat();
						if(l < 0.25f){
							col = 0x599918;
						}else if (l < 0.5f){
							col = 0xA1E80C;
						}else if (l < 0.75f){
							col = 0x328C00;
						}else{
							col = 0x618C07;
						}
					}
				}else if(i == 1){
					float l = Game.getInstance().rand.nextFloat();
					if(l < 0.25f){
						col = 0xF70600;
					}else if (l < 0.5f){
						col = 0xF7290F;
					}else if (l < 0.75f){
						col = 0xF73200;
					}else{
						col = 0xA62100;
					}
				}
				Cube.render(new Vec3((float)x,getHeight(x,z)-0.5f,(float)z), new Vec3(1f,1f,1f),col);
			}
		}
	}
	
	public void render(){
		if(Game.getInstance().player.universe == 0){
			Core.renderList(u1listID);
			Cube.render(new Vec3(50f,55f,50f), new Vec3(5f,5f,5f),0xF5F300);
		}else{
			Core.renderList(u2listID);
			Cube.render(new Vec3(50f,55f,50f), new Vec3(10f,10f,10f),0xF70600);
		}
	}
}
